import rwmap._frame as frame
from typing import Union

class KEY:
    empty_tile = "0"
    empty_tile_for_tilegroup = "e"
    tag_for_tile_notre = "|"

class NAME:
    Ground = "Ground"
    PathingOverride = "PathingOverride"
    Units = "Units"
    ItemsExtra = "ItemsExtra"
    Items = "Items"
    GroundDetails = "GroundDetails"
    Triggers = "Triggers"
    UnitObject = "UnitObject"

class OBJECTTYPE:
    team_info = "team_info"
    unitAdd = "unitAdd"
    unitRemove = "unitRemove"
    unitDetect = "unitDetect"
    mapText = "mapText"
    camera_pan = "camera_pan"
    objective = "objective"
    basic = "basic"
    fall = "fall"
    rotate = "rotate"
    move = "move"
    point = "point"
    set_team = "set_team"
    ai_allow_full_use = "ai_allow_full_use"
    disable_unit_ai = "disable_unit_ai"
    moveCamera = "moveCamera"
    changeCredits = "changeCredits"
    teamTags = "teamTags"
    teamTagDetect = "teamTagDetect"

class OBJECTDE:
    x = "x" 
    y = "y"
    width = "width"
    height = "height"
    type = "type"
    id = "id"
    name = "name"

class OBJECTOP:
    credits = "credits"
    disabledAI = "disabledAI"
    lockAiDifficulty = "lockAiDifficulty"
    ai = "ai"
    allyGroup = "allyGroup"
    basicAI = "basicAI"
    unitType = "unitType"
    onlyIdle = "onlyIdle"
    onlyBuildings = "onlyBuildings"
    onlyMainBuildings = "onlyMainBuildings"
    onlyEmptyQueue = "onlyEmptyQueue"
    onlyBuilders = "onlyBuilders"
    onlyOnResourcePool = "onlyOnResourcePool"
    onlyAttack = "onlyAttack"
    onlyAttackAir = "onlyAttackAir"
    onlyTechLevel = "onlyTechLevel"
    includeIncomplete = "includeIncomplete"
    minUnits = "minUnits"
    maxUnits = "maxUnits"
    onlyWithTag = "onlyWithTag"
    target = "target"
    unload = "unload"
    dir = "dir"
    addTeamTags = "addTeamTags"
    removeTeamTags = "removeTeamTags"
    teamTag = "teamTag"
    text = "text"
    textColor = "textColor"
    textSize = "textSize"
    textOffsetX = "textOffsetX"
    textOffsetY = "textOffsetY"
    style = "style"
    text_lang = "text_lang"
    set = "set"
    add = "add"
    spawnUnits = "spawnUnits"
    neutralTeam = "neutralTeam"
    spawnChance = "spawnChance"
    maxSpawnLimit = "maxSpawnLimit"
    techLevel = "techLevel"
    gridAlign = "gridAlign"
    skipIfOverlapping = "skipIfOverlapping"
    falling = "falling"
    offsetX = "offsetX"
    offsetY = "offsetY"
    offsetRandomX = "offsetRandomX"
    offsetRandomY = "offsetRandomY"
    offsetRandomXY = "offsetRandomXY"
    offsetHeight = "offsetHeight"
    offsetDir = "offsetDir"
    offsetRandomDir = "offsetRandomDir"
    team = "team"
    globalMessage = "globalMessage"
    globalMessage_delayPerChar = "globalMessage_delayPerChar"
    globalMessage_textColor = "globalMessage_textColor"
    debugMessage = "debugMessage"
    warmup = "warmup"
    delay = "delay"
    resetActivationAfter = "resetActivationAfter"
    repeatDelay = "repeatDelay"
    alsoActivate = "alsoActivate"
    id = "id"
    activatedBy = "activatedBy"
    deactivatedBy = "deactivatedBy"
    allToActivate = "allToActivate"
    activateIds = "activateIds"
    whenActivatedIds = "whenActivatedIds"
    showOnMap = "showOnMap"
    unit = "unit"

class MAPTYPE:
    skirmish = "skirmish"
    challenge = "challenge"
    survival = "survival"
    mission = "mission"

class FOG:
    NONE = "NONE"
    map = "map"
    los = "los"

class WIN:
    NONE = "NONE"
    mainBuildings = "mainBuildings"
    allUnitsAndBuildings = "allUnitsAndBuildings"
    allBuildings = "allBuildings"
    commandCenter = "commandCenter"
    requiredObjectives = "requiredObjectives"

class COO:
    SIZE_STANDARD = frame.Coordinate(20, 20)

class TYPE:
    tileid = Union[int, tuple[str, int], frame.TagCoordinate]

class UNIT:
    turret_flamethrower = "turret_flamethrower"
    turret_artillery = "turret_artillery"
    turretT3 = "turretT3"
    turretT2 = "turretT2"
    turret = "turret"
    supplyDepot = "supplyDepot"
    repairbay = "repairbay"
    outpostT1 = "outpostT1"
    outpostT2 = "outpostT2"
    builder = "builder"
    landFactory = "landFactory"
    mechGun = "mechGun"
    mechMissile = "mechMissile"
    mechBunker = "mechBunker"
    mechBunkerDeployed = "mechBunkerDeployed"
    heavyArtillery = "heavyArtillery"
    bugMeleeLarge = "bugMeleeLarge"
    hovercraft = "hovercraft"
    antiAirTurret = "antiAirTurret"
    c_antiAirTurretT2 = "c_antiAirTurretT2"
    c_antiAirTurretT3 = "c_antiAirTurretT3"
    combatEngineer = "combatEngineer"
    mechEngineer = "mechEngineer"
    scout = "scout"
    c_tank = "c_tank"
    c_artillery = "c_artillery"
    heavyhoverTank = "heavyhoverTank"
    laserTank = "laserTank"
    mechLightning = "mechLightning"
    mechFlame = "mechFlame"
    experimentalTank = "experimentalTank"
    experimentalSpider = "experimentalSpider"
    hoverTank = "hoverTank"
    heavyTank = "heavyTank"
    plasmaTank = "plasmaTank"
    mammothTank = "mammothTank"
    missileTank = "missileTank"
    mechArtillery = "mechArtillery"
    mechLaser = "mechLaser"
    mechHeavyMissile = "mechHeavyMissile"
    mechMinigun = "mechMinigun"
    experimentalHoverTank = "experimentalHoverTank"
    lightGunship = "lightGunship"
    c_interceptor = "c_interceptor"
    helicopter = "helicopter"
    gunShip = "gunShip"
    heavyInterceptor = "heavyInterceptor"
    dropship = "dropship"
    amphibiousjet = "amphibiousjet"
    bomber = "bomber"
    missileAirship = "missileAirship"
    aaBeamGunship = "aaBeamGunship"
    spyDrone = "spyDrone"
    fireBee = "fireBee"
    experimentalDropship = "experimentalDropship"
    gunBoat = "gunBoat"
    hovercraft = "hovercraft"
    attackSubmarine = "attackSubmarine"
    heavyBattleship = "heavyBattleship"
    heavyMissileShip = "heavyMissileShip"
    nautilusSubmarine = "nautilusSubmarine"
    heavyAAShip = "heavyAAShip"
    builderShip = "builderShip"
    missileship = "missileship"
    battleShip = "battleShip"
    heavySub = "heavySub"
    experiementalCarrier = "experiementalCarrier"
    nautilusSubmarineSurface = "nautilusSubmarineSurface"
    landFactory = "landFactory"
    mechFactoryT2 = "mechFactoryT2"
    mechFactory = "mechFactory"
    seaFactory = "seaFactory"
    extractor = "extractor"
    extractorT2 = "extractorT2"
    extractorT3 = "extractorT3"
    extractorT3_reinforced = "extractorT3_reinforced"
    extractorT3_overclocked = "extractorT3_overclocked"
    c_turret_t1_lightning = "c_turret_t1_lightning"
    antiAirTurretFlak = "antiAirTurretFlak"
    laserDefence = "laserDefence"
    laboratory = "laboratory"
    antiNukeLauncherC = "antiNukeLauncherC"
    creditsCrates = "creditsCrates"
    airFactory = "airFactory"
    experimentalLandFactory = "experimentalLandFactory"
    commandCenter = "commandCenter"
    fabricator = "fabricator"
    fabricatorT2 = "fabricatorT2"
    fabricatorT3 = "fabricatorT3"
    c_turret_t2_artillery = "c_turret_t2_artillery"
    c_turret_t2_lightning = "c_turret_t2_lightning"
    nukeLauncherC = "nukeLauncherC"
    crystal_mid = "crystal_mid"
    bugNest = "bugNest"
    bugFly = "bugFly"
    bugWasp = "bugWasp"
    bugBee = "bugBee"
    bugTurret = "bugTurret"
    bugGenerator = "bugGenerator"
    bugGeneratorT2 = "bugGeneratorT2"
    bugSpore = "bugSpore"
    bugMelee = "bugMelee"
    bugPickup = "bugPickup"
    bugRanged = "bugRanged"
    bugRangedT2 = "bugRangedT2"
    bugExtractor = "bugExtractor"
    bugExtractorT2 = "bugExtractorT2"
    robotCrab = "robotCrab"
    megaTank = "megaTank"
    experimentalGunship = "experimentalGunship"
    mechFlyingTakeoff = "mechFlyingTakeoff"
    wall_v = "wall_v"
    modularSpider = "modularSpider"
    missing = "missing"
    robotCrabWater = "robotCrabWater"
    tankDestroyer = "tankDestroyer"
    experimentalGunshipLanded = "experimentalGunshipLanded"
    mechFlyingLanded = "mechFlyingLanded"
    spreadingFire = "mechFlyingTakeoff"
    editorOrBuilder = "editorOrBuilder"
    crystalResource = "crystalResource"
    mammothtank = "mammothtank" 
    modularSpider_emptySlot = "modularSpider_emptySlot"
    modularSpider_antiairT2 = "modularSpider_antiairT2"
    modularSpider_antiair = "modularSpider_antiair"
    modularSpider_artillery = "modularSpider_artillery"
    modularSpider_laserdefense = "modularSpider_laserdefense"
    modularSpider_shieldGen = "modularSpider_shieldGen"
    modularSpider_lightning = "modularSpider_lightning"
    modularSpider_blink = "modularSpider_blink"
    modularSpider_antinuke = "modularSpider_antinuke"
    modularSpider_antiairFlak = "modularSpider_antiairFlak"
    modularSpider_fabricatorT2 = "modularSpider_fabricatorT2"
    modularSpider_fabricator = "modularSpider_fabricator"
    modularSpider_gunturretT2 = "modularSpider_gunturretT2"
    modularSpider_gunturret = "modularSpider_gunturret"
    modularSpider_speed = "modularSpider_speed"
    modularSpider_smallgunturretT2 = "modularSpider_smallgunturretT2"
    modularSpider_smallgunturret = "modularSpider_smallgunturret"